
(*  Alumno: Juan P. Zofo Prez          Titulacion: I.T.I.Gestin
    Fecha: 27 de Septiembre de 1999      Curso: 1C              *)

IMPLEMENTATION MODULE Marciano;
IMPORT IO, Window, Lib;
FROM Storage IMPORT Available, ALLOCATE, DEALLOCATE;

PROCEDURE Crear(VAR error:BOOLEAN):ESPACIO;
VAR
  espacio:ESPACIO;
  x, y:CARDINAL;
BEGIN
    error:=FALSE;
    IF Available(SIZE(SPACE)) THEN
       NEW(espacio);                  (* Si hay espacio en memoria para *)
       FOR y:=1 TO 25 DO              (* crear la matriz, la relleno de *)
           FOR x:=1 TO 60 DO          (* 'blancos' para evitar basura.  *)
               espacio^[y,x]:=' ';
           END;
       END;
       FOR y:=1 TO 5 DO               (* A continuacin se coloca la    *)
           FOR x:=1 TO 10 DO          (* formacin de enemigos que      *)
               espacio^[y,x]:='';    (* apareceran inicialmente en la  *)           END;(*FOR ordenadas*)
           IO.WrLn;                   (* parte izquierda superior de la *)
       END;(* FOR abcisas*)           (* pantalla.                      *)
       espacio^[25,30]:='';          (* Mi nave (''), se coloca en la *)
    ELSE                              (* parte inferior (linea 25) y en *)
       error:=TRUE;                   (* el centro(columna 30/60.       *)
       espacio:=NIL;                  (* Si no hay espacio en memoria   *)
    END;(*IF*)                        (* error a TRUE y retorno NIL     *)
    RETURN espacio;
END Crear;

PROCEDURE Destruir(VAR espacio:ESPACIO);
BEGIN
    DISPOSE(espacio);
END Destruir;

PROCEDURE SonidoMarcianoMuerto();
BEGIN
    Lib.Sound(125);
    Lib.Delay(10);
    Lib.NoSound();
END SonidoMarcianoMuerto;

PROCEDURE SonidoDisparo();
BEGIN
    Lib.Sound(1250);
    Lib.Delay(10);
    Lib.NoSound();
END SonidoDisparo;

PROCEDURE MatarMarciano(VAR espacio:ESPACIO; coordenadas:COORDENADAS;
                                            VAR muertos:CARDINAL);
BEGIN
    espacio^[coordenadas.y,coordenadas.x]:=' ';   (* Borramos el enemigo *)
    INC(muertos);                                 (* enemigo situado en  *)
    SonidoMarcianoMuerto();                       (* coordenadas e incre-*)
END MatarMarciano;                                (* tamos el n de muertos*)


PROCEDURE VisualizarEspacio(espacio:ESPACIO);
VAR
  x,y:CARDINAL;
BEGIN
    FOR y:=1 TO 25 DO
        FOR x:=1 TO 60 DO
            Window.GotoXY(x,y);
            IO.WrChar(espacio^[y,x]);
        END;
    END;
END VisualizarEspacio;

          (* Mueve el escuadron enemigo hacia abajo  *)
PROCEDURE MoverAbajoEscuadron(VAR espacio:ESPACIO; VAR coorescuadron:COORESCUADRON;
                                  VAR muertos:CARDINAL; VAR minavedestruida:BOOLEAN);
VAR
  numlineasbajar:CARDINAL;    (*->Lineas a bajarse cuando se llege a la parte *)
  origen, destino:CHAR;       (* inferior de la pantalla.                     *)
  nuevay, x, y, i:CARDINAL;   (* nuevay ser la primera linea vacia por debajo*)
  marcianomuerto:COORDENADAS; (* del escuadron.                               *)

BEGIN
    numlineasbajar:=5;           (* En principio habr que bajar las 5 lineas *)
    nuevay:=coorescuadron.y+5;   (* Primera linea vacia ser 'y+5', pero si   *)
    IF (nuevay>25) THEN          (* 'y+5'>25 => nos salimos de la pantalla, lo*)
       REPEAT                    (* decrementamos hasta que entre en el rango *)
            DEC(nuevay);         (* disponible. *)
            DEC(numlineasbajar);
       UNTIL (nuevay<26)OR (numlineasbajar=0);
    END;                                (* Para el n de lineas a bajar y desde *)
       FOR i:=1 TO numlineasbajar DO    (* la posicion x del primer enemigo   *)
           FOR x:=coorescuadron.x TO (coorescuadron.x+9) DO (* hasta el decimo*)
               destino:=espacio^[nuevay,x]; (* 'destino'caracter sito en la casilla*)
               origen:=espacio^[nuevay-1,x];(* destino.'origen'caracter sito en...*)
               IF (origen='')AND(destino='!') THEN  (* Bomba+enemigo=muerto *)
                  marcianomuerto.x:=x;          (* coordenada x enemigo muerto *)
                  marcianomuerto.y:=nuevay;     (* coordenada y enemigo muerto *)
                  MatarMarciano(espacio,marcianomuerto,muertos); (* Matar enemigo *)
                  espacio^[nuevay-1,x]:=' ';
               ELSIF ((origen='') AND (destino=' ')) THEN   (*' '+enemigo=>avance*)
                  espacio^[nuevay-1,x]:=' ';
                  espacio^[nuevay,x]:=origen;
               ELSIF ((origen='') AND (destino='')) THEN
                  minavedestruida:=TRUE;      (* enemigo+mi nave=>derrotado *)
               END;
           END;
           DEC(nuevay); (* Bajada una fila entera, bajo la anterior *)
       END;
       INC(coorescuadron.y); (* Bajado todo el escuadron, actualizo su posicion *)
END MoverAbajoEscuadron;

        (* Mueve el escuadron enemigo a la derecha *)
PROCEDURE MoverDerechaEscuadron(VAR espacio:ESPACIO; VAR coorescuadron:COORESCUADRON;
                                    VAR muertos:CARDINAL; VAR minavedestruida:BOOLEAN);
VAR
  nuevax, y, i:CARDINAL;
  origen, destino:CHAR;
  marcianomuerto:COORDENADAS;

BEGIN
    IF ((coorescuadron.y+4)<=25) THEN         (* Si no alcanzamos la parte inferior =>*)
       FOR y:=coorescuadron.y TO (coorescuadron.y+4) DO   (* desplazo todas las lineas *)
           nuevax:=coorescuadron.x+10;  (* nuevax->Primera columna libre a la derecha *)
           FOR i:=1 TO 10 DO            (* Desplazo los 10 enemigos una casilla a la  *)
               destino:=espacio^[y,nuevax];    (* derecha *)
               origen:=espacio^[y,nuevax-1];
               IF (origen='')AND(destino='!') THEN   (* enemigo+bomba=muerto *)
                  marcianomuerto.x:=nuevax;
                  marcianomuerto.y:=y;
                  MatarMarciano(espacio,marcianomuerto,muertos);
                  espacio^[y,nuevax-1]:=' ';
               ELSIF (origen='') AND (destino=' ')THEN  (* enemigo+' '=avance *)
                  espacio^[y,nuevax-1]:=' ';
                  espacio^[y,nuevax]:=origen;
               ELSIF ((origen='') AND (destino='')) THEN
                  minavedestruida:=TRUE;      (* enemigo + mi nave = derrotado *)
               END;
               DEC(nuevax);      (* desplazada una linea entera paso a la anterior *)
           END;
       END;
       INC(coorescuadron.x);  (* Desplazado todo el escuadron actualizo su posicion *)
    ELSE
       FOR y:=coorescuadron.y TO 25 DO  (* Si estamos ya en la parte inferior se   *)
           nuevax:=coorescuadron.x+10;  (* hace el mismo algoritmo pero solo hasta *)
           FOR i:=1 TO 10 DO            (* la ultima linea de la pantalla(linea 25)*)
               destino:=espacio^[y,nuevax];
               origen:=espacio^[y,nuevax-1];
               IF (origen='')AND(destino='!') THEN
                  marcianomuerto.x:=nuevax;
                  marcianomuerto.y:=y;
                  MatarMarciano(espacio,marcianomuerto,muertos);
                  espacio^[y,nuevax-1]:=' ';
               ELSIF (origen='') AND (destino=' ')THEN
                  espacio^[y,nuevax-1]:=' ';
                  espacio^[y,nuevax]:=origen;
               ELSIF ((origen='') AND (destino='')) THEN
                  minavedestruida:=TRUE;
               END;
               DEC(nuevax);
           END;
         END;
       INC(coorescuadron.x);
    END;
END MoverDerechaEscuadron;

        (* Mueve el escuadron enemigo a la izquierda *)
PROCEDURE MoverIzquierdaEscuadron(VAR espacio:ESPACIO; VAR coorescuadron:COORESCUADRON;
                                      VAR muertos:CARDINAL; VAR minavedestruida:BOOLEAN);
VAR
  nuevax, y, i:CARDINAL;
  origen, destino:CHAR;
  marcianomuerto:COORDENADAS;
                                 (* Procedimiento analogo al 'MoverDerecha...'*)
BEGIN
    IF ((coorescuadron.y+4)<=25) THEN
       FOR y:=coorescuadron.y TO (coorescuadron.y+4) DO
           nuevax:=coorescuadron.x-1;
           FOR i:=1 TO 10 DO
               destino:=espacio^[y,nuevax];
               origen:=espacio^[y,nuevax+1];
               IF (origen='')AND(destino='!') THEN
                  marcianomuerto.x:=nuevax;
                  marcianomuerto.y:=y;
                  MatarMarciano(espacio,marcianomuerto,muertos);
                  espacio^[y,nuevax+1]:=' ';
               ELSIF (origen='')AND(destino=' ') THEN
                  espacio^[y,nuevax+1]:=' ';
                  espacio^[y,nuevax]:=origen;
               ELSIF ((origen='') AND (destino='')) THEN
                  minavedestruida:=TRUE;
               END;
               INC(nuevax);
           END;
       END;
       DEC(coorescuadron.x);
    ELSE
       FOR y:=coorescuadron.y TO 25 DO
           nuevax:=coorescuadron.x-1;
           FOR i:=1 TO 10 DO
               destino:=espacio^[y,nuevax];
               origen:=espacio^[y,nuevax+1];

               IF (origen='')AND(destino='!') THEN
                  marcianomuerto.x:=nuevax;
                  marcianomuerto.y:=y;
                  MatarMarciano(espacio,marcianomuerto,muertos);
                  espacio^[y,nuevax+1]:=' ';
               ELSIF (origen='')AND(destino=' ') THEN
                  espacio^[y,nuevax+1]:=' ';
                  espacio^[y,nuevax]:=origen;
               ELSIF ((origen='') AND (destino='')) THEN
                  minavedestruida:=TRUE;
               END;
               INC(nuevax);
           END;

       END;
       DEC(coorescuadron.x);
    END;
END MoverIzquierdaEscuadron;

        (*Mueve el escuadron segun los parametros de coorescuadron *)
PROCEDURE MoverEscuadron(VAR espacio:ESPACIO; VAR coorescuadron:COORESCUADRON;
                             VAR muertos:CARDINAL; VAR minavedestruida:BOOLEAN);
VAR
  x, y:CARDINAL;

BEGIN
IF (coorescuadron.dir=derecha) THEN
   IF (coorescuadron.x=51) THEN (* Si vamos a la derecha pero se acaba el espacio *)
      MoverAbajoEscuadron(espacio, coorescuadron, muertos, minavedestruida);
      coorescuadron.dir:=izquierda;  (* Cambio direccion *)
   ELSE
      MoverDerechaEscuadron(espacio, coorescuadron, muertos, minavedestruida);
   END;
ELSIF (coorescuadron.dir=izquierda) THEN
    IF (coorescuadron.x=1) THEN  (* Si vamos a la izqu. pero se acaba el espacio *)
       MoverAbajoEscuadron(espacio, coorescuadron, muertos, minavedestruida);
       coorescuadron.dir:=derecha;  (* Cambio direccion *)
    ELSE
       MoverIzquierdaEscuadron(espacio, coorescuadron, muertos, minavedestruida);
    END;
END;
END MoverEscuadron;


        (* Mueve mi nave hacia el lado indicado en el parametro direccion *)
PROCEDURE MoverNave(VAR espacio:ESPACIO; VAR posicion:CARDINAL; direccion:DIRECCION);
BEGIN
    IF (direccion=izquierda) AND (posicion>1) THEN   (* Muevo solo si puedo *)
       espacio^[25,posicion]:=' ';
       espacio^[25,posicion-1]:='';
       DEC(posicion);
    ELSIF (direccion=derecha) AND (posicion<60) THEN  (* Muevo solo si puedo *)
       espacio^[25,posicion]:=' ';
       espacio^[25,posicion+1]:='';
       INC(posicion);
    END;
END MoverNave;

        (* Mueve mi nave segun la tecla pulsada *)
PROCEDURE MoverMiNave(VAR espacio:ESPACIO; VAR posicion:CARDINAL;
                          keypulsada:CHAR; VAR minavedestruida:BOOLEAN);

BEGIN
       IF (keypulsada='k') OR (keypulsada='K') THEN (* Mover izquierda *)
          IF (posicion>1) AND (espacio^[25,posicion-1]='') THEN
             minavedestruida:=TRUE;   (* mi nave+enemigo=derrotado *)
          ELSE
             MoverNave(espacio,posicion,izquierda);
          END;
       ELSIF (keypulsada='l') OR (keypulsada='L') THEN (* Mover derecha *)
          IF (posicion<60) AND (espacio^[25,posicion+1]='') THEN
             minavedestruida:=TRUE;  (* mi nave+enemigo=derrotado *)
          ELSE
             MoverNave(espacio,posicion,derecha);
          END;
       END;

END MoverMiNave;

        (* Este detecta la presion de una tecla y segun cual sea dispara o
           mueve mi nave, ademas desplaza por el espacio los misiles ya
           disparados. 'posicion' indica la posicion de mi nave dentro
           de la fila de abajo (25) *)
PROCEDURE  Disparar(VAR espacio:ESPACIO; VAR posicion:CARDINAL;
                        VAR muertos:CARDINAL; VAR minavedestruida:BOOLEAN);
VAR
  keypulsada:CHAR;
  marcianomuerto:COORDENADAS;
  y, x:CARDINAL;

BEGIN

    IF IO.KeyPressed() THEN
       keypulsada:=IO.RdKey();
       IO.RdLn;
       IF (keypulsada='d') OR (keypulsada='D') THEN(* Si pulso 'd'=> disparo *)
          IF (espacio^[24,posicion]='') THEN      (* pero si el la linea de *)
             marcianomuerto.y:=24;                 (* salida hay un enemigo  *)
             marcianomuerto.x:=posicion;           (* directamente lo matamos*)
             MatarMarciano(espacio,marcianomuerto,muertos);
          ELSE
             espacio^[24,posicion]:='!';
          END;
          SonidoDisparo();
       ELSIF (keypulsada='k') OR (keypulsada='K') OR   (* Mover derecha *)
             (keypulsada='l') OR (keypulsada='L') THEN (* Mover izquierda *)
             MoverMiNave(espacio,posicion,keypulsada,minavedestruida);
       END;
     END;
     FOR y:=1 TO 25 DO     (* Recorro el espacio y muevo todos los disparos *)
         FOR x:=1 TO 60 DO
             IF (y=1) AND (espacio^[y,x]='!') THEN  (* Se acaba el espacio *)
                espacio^[y,x]:=' ';
             ELSIF (y>1) AND (espacio^[y,x]='!') AND (espacio^[y-1,x]=' ') THEN
                espacio^[y,x]:=' ';     (* Bomba + ' ' = avance *)
                espacio^[y-1,x]:='!';
             ELSIF (y>1) AND (espacio^[y,x]='!') AND (espacio^[y-1,x]='') THEN
                espacio^[y,x]:=' ';       (* Bomba + enemigo = muerto *)
                marcianomuerto.y:=y-1;
                marcianomuerto.x:=x;
                MatarMarciano(espacio,marcianomuerto,muertos);
             END;
         END;
     END;
END Disparar;

END Marciano.